import java.io.Serializable;


public class Address implements Serializable{

	private String[] address = new String[4];
	
	/**
	 * Constructor: creates a new address. all may be null
	 * @param street
	 * @param city
	 * @param zip
	 * @param country
	 */
	public Address(String street, String city, String zip, String country){
		address[0] = street;
		address[1] = city;
		address[2] = zip;
		address[3] = country;
	}
	
	/**
	 * returns the street
	 * @return this.address[0]
	 */
	public String getStreet(){
		return address[0];
	}
	
	/**
	 * returns the city
	 * @return this.address[1]
	 */
	public String getCity(){
		return address[1];
	}
	
	/**
	 * returns the zip-code
	 * @return this.address[2]
	 */
	public String getZip(){
		return address[2];
	}
	
	/**
	 * returns the country
	 * @return this.address[3]
	 */
	public String getCountry(){
		return address[3];
	}
	
	/**
	 * returns the string representation of the address
	 */
	public String toString(){
		return new String(address[0] + "; " +
						  address[1] + "; " +
						  address[2] + "; " +
						  address[3]);
	}
}
