public class Assignment3 {
	/** 
	 * @param nums - an array of integers (may be empty).
	 * @return maxSpan - the maximum span of the array, where span
	 * is the number of objects between two occurrences of the same
	 * number in the array.
	 */
	public static int maxSpan(int[] nums)	{
		int maxSpan = 0;
		for(int i = 0; i < nums.length; i++){
			int curr = nums[i];
			int j = nums.length - 1;
			while(j >= 0){
				if (nums[j] == curr) break;
				else j--;
			}
			maxSpan = (maxSpan < (j - i + 1) ? (j - i + 1):maxSpan);
		}
		return maxSpan;
	}
	
	/**
	 * *** ADDED PROCEDURE FOR fix34 & fix45 ***
	 * @param nums - an integers array with the same number of staticNum
	 * and followerNum. staticNum is not the last object in the array.
	 * @param staticNum - some integer number that the array contains (according
	 * to the definition of nums).
	 * @param followerNum - some integer number that the array contains (according
	 * to the definition of nums).
	 * @return an integers array identical to nums only where all the following
	 * cells after a cell that contains staticNum had switched contents with
	 * some cells that contain followerNum.
	 * e.g.: {1, 3, 1, 4}, 3, 4 ==> {1, 3, 4, 1}
	 */
	public static int[] fixGeneric(int[] nums, int staticNum, int followerNum){
		//Creating arrays of indices of static-numbers and their followers:
		int[] statics = new int[nums.length / 2];
		int[] followers = new int[nums.length / 2];
		int istatics = 0;
		int ifollowers = 0;
		for(int i = 0; i < nums.length; i++){
			if (nums[i] == staticNum){
				statics[istatics] = i;
				istatics++;
			}
			if (nums[i] == followerNum){
				followers[ifollowers] = i;
				ifollowers++;
			}
		}
		//Changing the array - for each static, the following cell will
		//be replaced with some follower:
		int temp;
		for(int i = 0; i < istatics; i++){
			temp = nums[statics[i] + 1];
			nums[statics[i] + 1] = followerNum;
			nums[followers[i]] = temp;
		}
		return nums;
	}

	/**
	 * @param nums - an array of integers that consists:
	 * - same number of 3's and 4's
	 * - every 3 has a number after it that is not a 3 or a 4
	 * - a 3 appears in the array before any 4
	 * @return an array that contains exactly the same numbers as the
	 * given array, rearranged that every 3 is immediately followed
	 * by a 4, and every 3 stays at its original position.
	 */
	public static int[] fix34(int[] nums)	{
		return fixGeneric(nums, 3, 4);
	}

	/**
	 * @param nums - an array of integers that consists:
	 * - same number of 4's and 5's
	 * - every 4 has a number after it that is not a 4
	 * @return an array that contains exactly the same numbers as the
	 * given array, rearranged that every 4 is immediately followed
	 * by a 5, and every 4 stays at its original position.
	 */
	public static int[] fix45(int[] nums)	{
		return fixGeneric(nums, 4, 5);
	}

	/**
	 * 
	 * @param start - an index (integer) to start the check, between
	 * 0 and nums.length-1 
	 * @param nums - an array of integers
	 * @param target - an integer
	 * @return true if the array nums starting from index start contains
	 * any partial sum equals to target, otherwise returns false.
	 */
	public static boolean groupSum(int start, int[] nums, int target) {
		if (start == (nums.length-1))
			return (nums[start]==target);
		else {
			return (
					(nums[start]==target) ||
					groupSum((start+1), nums, (target-nums[start])) ||
					groupSum((start+1), nums, target));
		}
	}

	/**
	 * @param str - a string.
	 * @return true if str contains the same number of subtrings "is" and "not",
	 * otherwise it returns false.
	 */
	public static boolean equalIsNot(String str) {
		int isCount = 0;
		int isIndex = -2;
		int notCount = 0;
		int notIndex = -2;
		//Count the times 'is' and 'not' appear in str:
		for(int i = 0; i < str.length(); i++){
			if ((str.indexOf("is", i) == -1) &&
				(str.indexOf("not", i) == -1)) break;
				//stop checking if "is" and "not" don't appear anymore
			else {
				if ((str.indexOf("is", i) != isIndex) &&
						(str.indexOf("is", i) != -1)){
					isCount++;
					isIndex = str.indexOf("is", i);
				}
				if ((str.indexOf("not", i) != notIndex) &&
						(str.indexOf("not", i) != -1)){
					notCount++;
					notIndex = str.indexOf("not", i);
				}
			}
		}
		return (isCount == notCount);
	}

	/**
	 * @param str - a string.
	 * @return str where all the substrings "is" that are not immediately preceded
	 * or followed by a letter, were changed into "is not".
	 */
	public static String notReplace(String str)	{
		String newStr = "";
		for(int i = 0; i < str.length(); i++){
			if (str.startsWith("is", i)){
				if (i > 0){
					if (i < (str.length()-2)){
						if ((Character.isLetter(str.charAt(i+2)) == false) &&
							(Character.isLetter(str.charAt(i-1)) == false)){
								newStr += "is not";
								i++;
						}else newStr += str.charAt(i);
					}else{
						newStr += "is not";
						i++;
					}
				}else{
					if (Character.isLetter(2) == false){
						newStr += "is not";
						i++;
					}
				}
			}else
				newStr += str.charAt(i);
		}
		return newStr;
	}
	
	/**
	 * @param a - an array of strings arranged in alphabetical order,
	 * lowercase and of the length of 1 exactly.
	 * @param b - same as a.
	 * @return the count of the number of strings which appear in both arrays.
	 */
	public static int commonTwo(String[] a, String[] b)	{
		int count = 0;
		int i = 0;
		int j = 0;
		while ((i < a.length)&&(j < b.length)){
			if (a[i].charAt(0) == b[j].charAt(0)){
				count++;
				i++;
				j++;
			}else{
				if (Character.getNumericValue(a[i].charAt(0)) <
					Character.getNumericValue(b[j].charAt(0))){
					i++;
				}else{
					j++;
				}
			}
		}
		return count;
	}
}
