import java.util.Arrays;

import com.sun.xml.internal.bind.v2.runtime.unmarshaller.XsiNilLoader.Array;

import sun.misc.Sort;



public class Ex02Q03 {
	static java.util.Random random = new java.util.Random();
	
	/**
	 * @return a random, uniformly distributed int value between 1 and 6 (inclusive).
	 */
	public static int rollDice(){
		return random.nextInt(6)+1;
	}
	
	
	/**
	 * Calculates the distribution of n rolls of a dice
	 * @param n - the number of rolls
	 * @return an array where the ith element is the number
	 * of rolls in which the result was i+1 
	 */
	public static int[] getRollDiceDistribution(int n){
		//	TODO: add code
		int[] rollDistArr = new int[6];
		for(int i = 0; i < n; i++) {
			rollDistArr[(rollDice() - 1)]++;
		}
		return rollDistArr;
	}
	
	/**
	 * Sorts the specified array of doubles into ascending or descending numerical order.
	 * @param arr - the array to be sorted
	 * @param ascending - specifies whether the order is increasing (true) or decreasing (false)
	 */
	public static void sort(double[] arr, boolean ascending){
		//	TODO: add code
		if (ascending == true)
			java.util.Arrays.sort(arr);
		else {
			java.util.Arrays.sort(arr);
			double[] resultArr = new double[arr.length];
			for(int i = 0; i < arr.length; i++){
				resultArr[i] = arr[arr.length - 1 - i];
			}
			System.arraycopy(resultArr, 0, arr, 0, arr.length);
			}
		}
	
	/**
	 * 
	 * @param n
	 * @return an array containing the list of primes equal or lower to n
	 */
	public static int[] computePrimes(int n){
		//	TODO: add code
		return computePrimes(2, n);
	}
	
	/**
	 * 
	 * @param m
	 * @param n
	 * @return an array containing the list of primes between m and n (inclusive)
	 */
	public static int[] computePrimes(int m, int n){
		// TODO: add code
		int[] EMPTY_ARRAY = new int[0];
		if(n < m) return EMPTY_ARRAY;
		else {
			int[] primeArr = new int[n - m + 1];
			int j = 0;
			for(int i = m; i <= n; i++) {
				if (isPrime(i) == true) {
					primeArr[j] = i;
					j++;
				}
			}
			int[] resultArr = new int[j];
			System.arraycopy(primeArr, 0, resultArr, 0, j);
			return resultArr;
		}
	}
	
	/**
	 * 
	 * @param n
	 * @return true if n is prime, false otherwise
	 */
	public static boolean isPrime(int n) {
		//The primality test will be checking division without remainder of
		//some i from 2 to the square-root of i; 
		if ((n == 2)||(n == 1)) {
			if (n == 2)
				return true;
			else return false;
		} else {
			int sqrtn = (int)(Math.ceil(Math.sqrt(n)));
			for(int i = 2; i <= sqrtn; i++){
				if ((n % i) == 0) {
					return false;
				}
			}
			return true;
		}
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		////////////////////////////////
		// Examples for tests
		////////////////////////////////
		
		System.out.println(java.util.Arrays.toString(getRollDiceDistribution(100))); // should sum to 100
		
		double[] arr1 = {1.0, -4.2, 9, 4, 0};
		sort(arr1, false);
		System.out.println(java.util.Arrays.toString(arr1)); // [9.0, 4.0, 1.0, 0.0, -4.2]
		sort(arr1, true);
		System.out.println(java.util.Arrays.toString(arr1));//[-4.2, 0.0, 1.0, 4.0, 9.0]
		
		System.out.println(java.util.Arrays.toString(computePrimes(13))); // [2, 3, 5, 7, 11, 13]
		System.out.println(java.util.Arrays.toString(computePrimes(4,13))); // [5, 7, 11, 13]		
		System.out.println(java.util.Arrays.toString(computePrimes(13, 4))); // []		
		System.out.println(java.util.Arrays.toString(computePrimes(4, 4))); // [] 
		System.out.println(java.util.Arrays.toString(computePrimes(23, 23))); // [23]			
	}
}
