/** @abst num/denom - num, denom are integers */
public interface ImmutableRational {

	// the change between this version and the mutable version is only
	// in the first 4 methods:
	/** returns this + otherRational
	 * @abst $ret = AF($prev(this)) + AF(otherRational)
	 */
	public ImmutableRational add(MutableRational otherRational);
	
	/** returns this - otherRational
	 * @abst $ret = AF($prev(this)) - AF(otherRational)
	 */
	public ImmutableRational subtract(MutableRational otherRational);
	
	/** returns this * otherRational
	 * @abst $ret = AF($prev(this)) * AF(otherRational)
	 */
	public ImmutableRational multiply(MutableRational otherRational);
	
	/** returns this / otherRational
	 * @abst $ret = AF($prev(this)) / AF(otherRational)
	 */
	public ImmutableRational divide(MutableRational otherRational);
	
	/** returns the decimal representation of this
	 *  @abst AF(this) = n.m
	 *  @abst $ret = "n.m"
	 */
	public String toDecimalString();
	
	/** returns the numerator of this
	 * @abst $ret = num
	 */
	public int getNumerator();
	
	/** returns the denominator of this
	 * @abst $ret = denom
	 */
	public int getDenominator();
}