/** @abst num/denom - num, denom are integers */
public interface MutableRational {

	/** changes this to be this + otherRational
	 * @abst AF(this) = AF($prev(this)) + AF(otherRational)
	 */
	public void add(MutableRational otherRational);
	
	/** changes this to be this - otherRational
	 * @abst AF(this) = AF($prev(this)) - AF(otherRational)
	 */
	public void subtract(MutableRational otherRational);
	
	/** changes this to be this * otherRational
	 * @abst AF(this) = AF($prev(this)) * AF(otherRational)
	 */
	public void multiply(MutableRational otherRational);
	
	/** changes this to be this / otherRational
	 * @abst AF(this) = AF($prev(this)) / AF(otherRational)
	 */
	public void divide(MutableRational otherRational);
	
	/** returns the decimal representation of this
	 *  @abst AF(this) = n.m
	 *  @abst $ret = "n.m"
	 */
	public String toDecimalString();
	
	/** returns the numerator of this
	 * @abst $ret = num
	 */
	public int getNumerator();
	
	/** returns the denominator of this
	 * @abst $ret = denom
	 */
	public int getDenominator();
}
