
public abstract class BinaryOp implements Expression{
	private Expression operand1;
	private Expression operand2;
	
	/**
	 * @pre exp1, exp2 != null
	 */
	public BinaryOp(Expression exp1, Expression exp2){
		this.operand1 = exp1;
		this.operand2 = exp2;
	}
	
	/**
	 * @pre exp1, exp2 != null
	 * @post $ret = the evaluation of the BinaryOp expression
	 */
	abstract protected Double operator(Expression exp1, Expression exp2);
	
	/**
	 * @post $ret = the string representation of the operator
	 */
	abstract protected String operatorToString();
	
	/**
	 * @post $ret = operator(operand1, operand2)
	 */
	public Double eval(){
		return operator(operand1, operand2);
	}
	
	/**
	 * @post $ret = the string representation of the expression
	 */
	public String toString(){
		String result = "";
		result += "(" + operand1 + ") " + operatorToString() + " (" + operand2 + ")";
		return result;
	}
}
