
public class CondExp extends TrenaryOp{
	
	/**
	 * 
	 * @pre exp1, exp2, exp3 != null
	 */
	public CondExp(Expression exp1, Expression exp2, Expression exp3){
		super(exp1, exp2, exp3);
	}
	
	/**
	 * @pre exp1, exp2, exp3 != null
	 * @post (exp1.eval() != 0.0) $implies $ret = exp2.eval()
	 * 						else  $implies $ret = exp3.eval()
	 */
	protected Double operator(Expression exp1, Expression exp2, Expression exp3){
		if (exp1.eval() != 0.0) return exp2.eval();
		else return exp3.eval();
	}
	
	/**
	 * @post $ret = "?"
	 */
	protected String operator1ToString(){
		return "?";
	}
	
	/**
	 * @$ret = ":"
	 */
	protected String operator2ToString(){
		return ":";
	}
}
