
public class Exponent extends BinaryOp{
	
	/**
	 * @pre exp1, exp2 != null
	 */
	public Exponent(Expression exp1, Expression exp2){
		super(exp1, exp2);
	}
	
	/**
	 * @pre exp1, exp2 != null
	 * @post $ret = (exp1.eval())^(exp2.eval())
	 */
	protected Double operator(Expression exp1, Expression exp2){
		Double result = 1.0;
		for(int i = 0; i < exp2.eval(); i++)
			result = result * exp1.eval();
		return result;
	}
	
	/**
	 * @post $ret = "^"
	 */
	protected String operatorToString(){
		return "^";
	}
}
