
public class Sum extends BinaryOp{
	
	/**
	 * @pre exp1, exp2 != null
	 */
	public Sum(Expression exp1, Expression exp2){
		super(exp1, exp2);
	}
	
	/**
	 * @pre exp1, exp2 != null
	 * @post $ret = (exp1.eval()) + (exp2.eval())
	 */
	protected Double operator(Expression exp1, Expression exp2){
		return exp1.eval() + exp2.eval();
	}
	
	/**
	 * @post $ret = "+"
	 */
	protected String operatorToString(){
		return "+";
	}
}
