
public class DifferenceSortedIterator<T extends Comparable<T>> extends CompositeSortedIterator<T>{

	/**
	 * Constructor
	 * creates an iterator for DifferenceSortedSet by its rules
	 * @pre a, b != null
	 */
	public DifferenceSortedIterator(SortedIterator<T> a, SortedIterator<T> b){
		super(a, b);
	}
	
	/**
	 * @post $ret = the next element of setA that doesn't appear in setB.
	 * 				If there are no more, returns null.
	 */
	protected T checkNext(){
		T result;
		if (aElement == null) return null;
		else if (bElement == null){
			result = aElement;
			advanceAElement();
		} else {
			if (aElement.compareTo(bElement) < 0){
				result = aElement;
				advanceAElement();
			} else if (aElement.compareTo(bElement) == 0){
				advanceAElement();
				advanceBElement();
				result = checkNext();
			} else {
				advanceBElement();
				result = checkNext();
			}
		} return result;
	}
}
