
public class DifferenceSortedSet<T extends Comparable<T>> extends CompositeSortedSet<T>{
	
	private SortedSet<T> setA;
	private SortedSet<T> setB;
	
	/**
	 * Constructor
	 * creates a SortedSet that contains all the elements in setA that are
	 * not in setB.
	 * @pre a, b != null
	 */
	public DifferenceSortedSet(SortedSet<T> a, SortedSet<T> b){
		setA = a;
		setB = b;
	}
	
	/**      
	 * Returns an Iterator for the elements of this set.
	*/
	public SortedIterator<T> iterator() {
		return new DifferenceSortedIterator<T>(setA.iterator(), setB.iterator());
	}
		
	/**
	 * @pre element != null
	 * @post $ret = true iff this set contains the element
	 */
	public boolean contains(T element){
		return (setA.contains(element) && !setB.contains(element));
	}
}