
public class MergedSortedIterator<T extends Comparable<T>> extends CompositeSortedIterator<T>{
	
	/**
	 * Constructor
	 * creates an iterator for MergedSortedSet by its rules
	 * @pre a, b != null
	 */
	public MergedSortedIterator(SortedIterator<T> a, SortedIterator<T> b){
		super(a, b);
	}
	
	/**
	 * @post $ret = the next intersection between setA and setB since the last one.
	 * 				If there are no more intersections, returns null.
	 */
	protected T checkNext(){
		if ((aElement != null) && (bElement != null)){
			if (aElement.equals(bElement)){
				T temp = aElement;
				advanceAElement();
				advanceBElement();
				return temp; 
			} else if (aElement.compareTo(bElement) < 0){
				advanceAElement();
				return checkNext();
			} else {
				advanceBElement();
				return checkNext();
			}
		} else return null;
	}
}
