

public class UnifiedSortedIterator<T extends Comparable<T>> extends CompositeSortedIterator<T>{

	/**
	 * Constructor
	 * creates an iterator for UnifiedSortedSet by its rules
	 * @pre a, b != null
	 */
	public UnifiedSortedIterator(SortedIterator<T> a, SortedIterator<T> b){
		super(a, b);
	}
	
	/**
	 * @post $ret = the next element of setA unified with setB, in ascending order.
	 * 				if both sets are empty, returns null.
	 */
	protected T checkNext(){
		T result = null;
		if (aElement == null){
			if (bElement == null) return result;
			else {
				result = bElement;
				advanceBElement();
			}
		} else if (bElement == null){
			result = aElement;
			advanceAElement();
		} else {
			if (aElement.compareTo(bElement) < 0){
				result = aElement;
				advanceAElement();
			} else if (aElement.compareTo(bElement) == 0){
				result = aElement;
				advanceAElement();
				advanceBElement();
			} else {
				result = bElement;
				advanceBElement();
			}
		} return result;
	}
}
