
public class UnifiedSortedSet<T extends Comparable<T>> extends CompositeSortedSet<T>{
	
	private SortedSet<T> setA;
	private SortedSet<T> setB;
	
	/**
	 * Constructor
	 * creates a SortedSet that contains all the elements of a and b.
	 * @pre a, b != null
	 */
	public UnifiedSortedSet(SortedSet<T> a, SortedSet<T> b){
		setA = a;
		setB = b;
	}
	
	/**      
	 * Returns an Iterator for the elements of this set.
	*/
	public SortedIterator<T> iterator() {
		return new UnifiedSortedIterator<T>(setA.iterator(), setB.iterator());
	}
	
	/**
	 * @pre element != null
	 * @post $ret = setA.contains(element) && setB.contains(element)
	 */
	public boolean contains(T element){
		return (setA.contains(element) || setB.contains(element));
	}
}
